VERSION 2.00
Begin Form CDPlayerF1 
   Caption         =   "CD Player"
   ClientHeight    =   2328
   ClientLeft      =   1224
   ClientTop       =   1632
   ClientWidth     =   6420
   Height          =   2748
   Left            =   1176
   LinkTopic       =   "Form1"
   ScaleHeight     =   2328
   ScaleWidth      =   6420
   Top             =   1260
   Width           =   6516
   Begin CommandButton RestartButton 
      Caption         =   "Restart"
      Height          =   552
      Left            =   1980
      TabIndex        =   12
      Top             =   1620
      Width           =   792
   End
   Begin Timer ActivityTimer 
      Interval        =   1000
      Left            =   5880
      Top             =   660
   End
   Begin CommandButton EjectButton 
      Caption         =   "Eject"
      Height          =   552
      Left            =   2940
      TabIndex        =   9
      Top             =   1620
      Width           =   672
   End
   Begin SpinButton TrackSelectSpin 
      Height          =   372
      Left            =   5160
      Top             =   1620
      Width           =   252
   End
   Begin TextBox CDTitleText 
      Height          =   312
      Left            =   1080
      TabIndex        =   2
      Top             =   180
      Width           =   5232
   End
   Begin CommandButton StopButton 
      Caption         =   "Stop"
      Height          =   552
      Left            =   1200
      TabIndex        =   1
      Top             =   1620
      Width           =   612
   End
   Begin CommandButton PlayButton 
      Caption         =   "Play"
      Height          =   552
      Left            =   420
      TabIndex        =   0
      Top             =   1620
      Width           =   612
   End
   Begin Label Label5 
      Alignment       =   2  'Center
      Caption         =   "Track Number"
      Height          =   192
      Left            =   4320
      TabIndex        =   13
      Top             =   2040
      Width           =   1332
   End
   Begin Label NumberOfTracksLabel 
      Height          =   252
      Left            =   1860
      TabIndex        =   11
      Top             =   780
      Width           =   432
   End
   Begin Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Number of Tracks:"
      Height          =   252
      Left            =   120
      TabIndex        =   10
      Top             =   780
      Width           =   1692
   End
   Begin Label TrackPositionLabel 
      Height          =   252
      Left            =   4620
      TabIndex        =   8
      Top             =   1200
      Width           =   1212
   End
   Begin Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Track Position:"
      Height          =   252
      Left            =   3300
      TabIndex        =   7
      Top             =   1200
      Width           =   1272
   End
   Begin Label TrackLengthLabel 
      Height          =   252
      Left            =   1860
      TabIndex        =   6
      Top             =   1200
      Width           =   1152
   End
   Begin Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Track Length:"
      Height          =   252
      Left            =   600
      TabIndex        =   5
      Top             =   1200
      Width           =   1212
   End
   Begin Label TrackNumberLabel 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "4"
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   13.8
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   372
      Left            =   4560
      TabIndex        =   4
      Top             =   1620
      Width           =   612
   End
   Begin Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "CD Title:"
      Height          =   312
      Left            =   180
      TabIndex        =   3
      Top             =   180
      Width           =   852
   End
End
Option Explicit

Dim UserWantsToPlay As Integer
Dim DiskIdentified As Integer
Dim DiskTitleRecord As DiskTitleRecords

Sub ActivityTimer_Timer ()
    Dim CurrentMode As String
    Dim TrackPosition
    Dim CurrentTrackNumber As String
    Dim CurrentPositionHours As Integer
    Dim StartPositionHours As Integer
    Dim CurrentPositionMinutes As Integer
    Dim StartPositionMinutes As Integer
    Dim CurrentPositionSeconds As Integer
    Dim StartPositionSeconds As Integer

    mciResult = mciSendString("status CDAudio mode", ReturnString, 127, 0)
    CurrentMode = CleanString(ReturnString)
    Select Case CurrentMode
      ' Insert whatever activity handling you wish in this
      ' Select Case statement.
      Case "not ready"
        UserWantsToPlay = False
        DiskIdentified = False
        'MsgBox "CD Drive Not Ready"
      Case "open"
        UserWantsToPlay = False
        DiskIdentified = False
        'MsgBox "Drive Open"
      Case "paused"
        UserWantsToPlay = False
      Case "playing", "stopped"
        If Not DiskIdentified Then
            CurrentTitleRecordNumber = GetDiskTitleRecord(DiskTitleRecord)
            If CurrentTitleRecordNumber <> 0 Then
                CDTitleText.Text = DiskTitleRecord.Title
              Else
                CDTitleText.Text = "<Title Unknown>"
              End If
            DiskIdentified = True
          End If
        mciResult = mciSendString("status CDAudio number of tracks", ReturnString, 127, 0)
        NumberOfTracksLabel.Caption = CleanString(ReturnString)
        mciResult = mciSendString("status CDAudio current track", ReturnString, 127, 0)
        CurrentTrackNumber = CleanString(ReturnString)
        TrackNumberLabel.Caption = CurrentTrackNumber
        mciResult = mciSendString("status CDAudio length track " & CurrentTrackNumber, ReturnString, 127, 0)
        TrackLengthLabel.Caption = Left$(CleanString(ReturnString), 5)
        
        mciResult = mciSendString("status CDAudio position", ReturnString, 127, 0)
        CurrentPositionHours = Val(Mid$(ReturnString, 4, 2)) \ 60
        CurrentPositionMinutes = Val(Mid$(ReturnString, 4, 2)) Mod 60
        CurrentPositionSeconds = Val(Mid$(ReturnString, 7, 2))
        
        mciResult = mciSendString("status CDAudio position track " & CurrentTrackNumber, ReturnString, 127, 0)
        StartPositionHours = Val(Mid$(ReturnString, 4, 2)) \ 60
        StartPositionMinutes = Val(Mid$(ReturnString, 4, 2)) Mod 60
        StartPositionSeconds = Val(Mid$(ReturnString, 7, 2))
        
        TrackPosition = TimeSerial(CurrentPositionHours, CurrentPositionMinutes, CurrentPositionSeconds) - TimeSerial(StartPositionHours, StartPositionMinutes, StartPositionSeconds)
        TrackPositionLabel.Caption = Format$(TrackPosition, "nn:ss")
        ' Restart playback after a track change.
        If (CurrentMode = "stopped") And UserWantsToPlay Then
            mciResult = mciSendString("play CDAudio", ReturnString, 127, 0)
          End If
      Case "seeking"
      'Case "stopped"
      End Select
    End Sub

Sub EjectButton_Click ()
    mciResult = mciSendString("stop CDAudio", ReturnString, 127, 0)
    If DiskIdentified Then
        DiskTitleRecord.Title = CDTitleText.Text
        SaveDiskTitleRecord DiskTitleRecord, CurrentTitleRecordNumber
      End If
    mciResult = mciSendString("set CDAudio door open", ReturnString, 127, 0)
    UserWantsToPlay = False
    End Sub

Sub Form_Load ()
    Dim CurrentMode As String

    OpenTitleFile
    mciResult = mciSendString("close CDAudio", ReturnString, 127, 0)
    mciResult = mciSendString("open CDAudio shareable", ReturnString, 127, 0)
    If mciResult <> 0 Then
        MsgBox "Unable to Open CD Audio Device", 16, "MCI Error"
        End
      Else
        mciResult = mciSendString("set CDAudio time format tmsf", ReturnString, 127, 0)
        mciResult = mciSendString("status CDAudio mode", ReturnString, 127, 0)
        CurrentMode = CleanString(ReturnString)
        DiskIdentified = False
        UserWantsToPlay = (CurrentMode = "playing")
        ActivityTimer.Enabled = True
      End If
    End Sub

Sub Form_Unload (Cancel As Integer)
    Dim mciResult As Integer

    mciResult = mciSendString("close CDAudio", ReturnString, 127, 0)
    End Sub

Sub PlayButton_Click ()
    mciResult = mciSendString("play CDAudio", ReturnString, 127, 0)
    If mciResult = 0 Then
        UserWantsToPlay = True
      End If
    End Sub

Sub RestartButton_Click ()
    mciResult = mciSendString("seek CDAudio to start", ReturnString, 127, 0)
    End Sub

Sub StopButton_Click ()
    mciResult = mciSendString("stop CDAudio", ReturnString, 127, 0)
    UserWantsToPlay = False
    If DiskIdentified Then
        DiskTitleRecord.Title = CDTitleText.Text
        SaveDiskTitleRecord DiskTitleRecord, CurrentTitleRecordNumber
      End If
    End Sub

Sub TrackSelectSpin_SpinDown ()
    Dim NewPosition As Integer
    
    NewPosition = MaxInt(Val(TrackNumberLabel.Caption) - 1, 1)
    mciResult = mciSendString("seek CDAudio to " & Str$(NewPosition), ReturnString, 127, 0)
    If UserWantsToPlay Then
        mciResult = mciSendString("play CDAudio", ReturnString, 127, 0)
      End If
    End Sub

Sub TrackSelectSpin_SpinUp ()
    Dim NewPosition As Integer
    
    NewPosition = MinInt(Val(TrackNumberLabel.Caption) + 1, Val(NumberOfTracksLabel.Caption))
    mciResult = mciSendString("seek CDAudio to " & Str$(NewPosition), ReturnString, 127, 0)
    If UserWantsToPlay Then
        mciResult = mciSendString("play CDAudio", ReturnString, 127, 0)
      End If
    End Sub

