VERSION 2.00
Begin Form HyperMedia2F1 
   Caption         =   "The Magic Hypermedia System"
   ClientHeight    =   5376
   ClientLeft      =   1932
   ClientTop       =   2916
   ClientWidth     =   7500
   Height          =   5796
   Left            =   1884
   LinkTopic       =   "Form1"
   ScaleHeight     =   5376
   ScaleWidth      =   7500
   Top             =   2544
   Width           =   7596
   Begin Frame PictureFrame 
      Height          =   2712
      Left            =   120
      TabIndex        =   4
      Top             =   180
      Width           =   7032
      Begin MCIWND MCIWnd1 
         AutosizeMovie   =   0   'False
         AutosizeWindow  =   -1  'True
         ErrorDlg        =   0   'False
         Filename        =   ""
         Height          =   24
         Left            =   540
         Menu            =   0   'False
         Playbar         =   0   'False
         Record          =   0   'False
         Repeat          =   0   'False
         Speed           =   1000
         TimeFormat      =   ""
         TimerFreq       =   500
         Top             =   360
         Visible         =   0   'False
         Volume          =   1000
         WantPosEvent    =   -1  'True
         Width           =   2172
         Zoom            =   100
      End
      Begin PictureBox ImagesPictureBox 
         AutoSize        =   -1  'True
         BorderStyle     =   0  'None
         ClipControls    =   0   'False
         Height          =   2880
         Left            =   0
         ScaleHeight     =   240
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   694
         TabIndex        =   5
         Top             =   -300
         Visible         =   0   'False
         Width           =   8328
      End
   End
   Begin HScrollBar ImageHScroll 
      Height          =   252
      LargeChange     =   100
      Left            =   120
      SmallChange     =   10
      TabIndex        =   3
      Top             =   2880
      Width           =   7032
   End
   Begin VScrollBar ImageVScroll 
      Height          =   2592
      Left            =   7140
      TabIndex        =   2
      Top             =   300
      Width           =   252
   End
   Begin VScrollBar TextVScroll 
      Height          =   1872
      Left            =   7140
      TabIndex        =   1
      Top             =   3300
      Width           =   252
   End
   Begin PictureBox TextPictureBox 
      ClipControls    =   0   'False
      Height          =   1872
      Left            =   120
      ScaleHeight     =   1848
      ScaleWidth      =   7008
      TabIndex        =   0
      Top             =   3312
      Width           =   7032
   End
End
Option Explicit

Sub Form_Load ()
    Dim OpenedImageDatabase As Integer

    FilesAreOpen = False
    CompileText App.Path & "\HyprMed3.Txt"
    OpenHyperbase App.Path & "\HyprMed3.XXX"
    OpenedImageDatabase = OpenImageDatabase()
    ImagesPictureBox.Left = 0
    ImagesPictureBox.Top = 0
    ImageHScroll.Visible = False
    ImageHScroll.Left = PictureFrame.Left
    ImageHScroll.Width = PictureFrame.Width
    ImageVScroll.Visible = False
    ImageVScroll.Top = PictureFrame.Top
    ImageVScroll.Height = PictureFrame.Height
    TextVScroll.Top = TextPictureBox.Top
    TextVScroll.Height = TextPictureBox.Height
    
    ' I added this code to initialize the ImagesPictureBox.
    ImagesPictureBox.Picture = LoadPicture("\grandcan\images\yakidawn.bmp")
    ImagesPictureBox.Left = 0
    ImagesPictureBox.Top = 0
    ActivateHotspots UCase$("\grandcan\images\yakidawn.bmp")
    
    DisplayFirstTopic TextPictureBox, TextVScroll
    End Sub

Sub Form_Unload (Cancel As Integer)
    DeactivateHotspots
    End Sub

Sub ImageHScroll_Change ()
    ImagesPictureBox.Left = -ImageHScroll.Value
    End Sub

Sub ImagesPictureBox_Change ()
    Dim Difference As Integer

    ImagesPictureBox.Left = 0
    ImagesPictureBox.Top = 0
    ImagesPictureBox.Visible = True
    If ImagesPictureBox.Width > PictureFrame.Width Then
        Difference = ImagesPictureBox.Width - PictureFrame.Width
        ImageHScroll.Value = 0
        ImageHScroll.LargeChange = MinInt(Difference, .33 * PictureFrame.Width)
        ImageHScroll.SmallChange = ImageHScroll.LargeChange \ 10
        ImageHScroll.Max = Difference
        ImageHScroll.Visible = True
      Else
        ImageHScroll.Visible = False
      End If
    If ImagesPictureBox.Height > PictureFrame.Height Then
        Difference = ImagesPictureBox.Height - PictureFrame.Height
        ImageVScroll.Value = 0
        ImageVScroll.LargeChange = MinInt(Difference, .33 * PictureFrame.Height)
        ImageVScroll.SmallChange = ImageVScroll.LargeChange \ 10
        ImageVScroll.Max = Difference
        ImageVScroll.Visible = True
      Else
        ImageVScroll.Visible = False
      End If
    End Sub

Sub ImagesPictureBox_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim TargetString As String

    TargetString = TargetFromPointInImage(X, Y)
    If Len(TargetString) > 0 Then
        DoHypermediaJump TargetString, TextPictureBox, ImagesPictureBox, TextVScroll, MCIWnd1
      End If
    End Sub

Sub ImageVScroll_Change ()
    ImagesPictureBox.Top = -ImageVScroll.Value
    End Sub

Sub MCIWnd1_ModeChange (Mode As String)
    If Mode = "stopped" Then
      MCIWnd1.Command = "Close"
      MCIWnd1.Visible = False
      End If
    End Sub

Sub TextPictureBox_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim TargetString As String

    TargetString = TargetFromPointInText(X, Y)
    If Len(TargetString) > 0 Then
        DoHypermediaJump TargetString, TextPictureBox, ImagesPictureBox, TextVScroll, MCIWnd1
      End If
    End Sub

Sub TextPictureBox_Paint ()
    DisplaySubject TextPictureBox, FirstTextLineNumber, LastTextLineNumber
    End Sub

Sub TextVScroll_Change ()
    FirstTextLineNumber = TextVScroll.Value
    TextPictureBox.Refresh
    End Sub

