Option Explicit

Type MIDIINCAPS
    wMid As Integer
    wPid As Integer
    vVersion As Integer
    szPname As String * 128
    End Type

Type RECT
    Left As Integer
    Top As Integer
    Right As Integer
    Bottom As Integer
    End Type

Declare Function midiInOpen Lib "MMSystem" (lphMidiIn As Integer, ByVal uDeviceID As Integer, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Integer
Declare Function midiInClose Lib "MMSystem" (ByVal hMidiIn As Integer) As Integer
Declare Function midiInReset Lib "MMSystem" (ByVal hMidiIn As Integer) As Integer
Declare Function midiInStart Lib "MMSystem" (ByVal hMidiIn As Integer) As Integer
Declare Function midiInStop Lib "MMSystem" (ByVal hMidiIn As Integer) As Integer
Declare Function midiInGetNumDevs Lib "MMSystem" () As Integer
Declare Function midiInGetDevCaps Lib "MMSystem" (ByVal wDeviceId As Integer, lpCaps As MIDIINCAPS, ByVal wSize As Integer) As Integer

Global Const CALLBACK_WINDOW = &H10000
Global Const MIDI_MAPPER = -1
Global Const MM_MIM_OPEN = &H3C1
Global Const MM_MIM_CLOSE = &H3C2

