VERSION 2.00
Begin Form MidiOutForm 
   Caption         =   "MIDI Out Experiment"
   ClientHeight    =   696
   ClientLeft      =   864
   ClientTop       =   1524
   ClientWidth     =   5256
   Height          =   1116
   Left            =   816
   LinkTopic       =   "Form1"
   ScaleHeight     =   696
   ScaleWidth      =   5256
   Top             =   1152
   Width           =   5352
   Begin TextBox ChannelText 
      Height          =   372
      Left            =   840
      TabIndex        =   3
      Text            =   "13"
      Top             =   180
      Width           =   312
   End
   Begin CommandButton SendMessageButton 
      Caption         =   "Send Note"
      Height          =   372
      Left            =   3420
      TabIndex        =   1
      Top             =   180
      Width           =   1752
   End
   Begin CommandButton OpenButton 
      Caption         =   "Open MIDI Device"
      Height          =   372
      Left            =   1380
      TabIndex        =   0
      Top             =   180
      Width           =   1752
   End
   Begin Label Label1 
      Caption         =   "MIDI Channel:"
      Height          =   432
      Left            =   60
      TabIndex        =   2
      Top             =   120
      Width           =   732
   End
End
Option Explicit

Dim NoteToggle As Integer
Dim hMidiOut As Integer
Dim MidiDeviceOpen As Integer
Dim MidiChannel As Integer

Sub Form_Load ()
    MidiDeviceOpen = False
    End Sub

Sub Form_Unload (Cancel As Integer)
    Dim RetValue As Integer

    RetValue = midiOutClose(hMidiOut)
    End Sub

Sub OpenButton_Click ()
    Dim RetValue As Integer

    If MidiDeviceOpen Then
        RetValue = midiOutClose(hMidiOut)
        OpenButton.Caption = "Open MIDI Device"
      Else
        RetValue = midiOutOpen(hMidiOut, MIDI_MAPPER, 0, 0, 0)
        OpenButton.Caption = "Close MIDI Device"
      End If
    MidiDeviceOpen = Not MidiDeviceOpen
    End Sub

Sub SendMessageButton_Click ()
    Dim RetValue As Integer
    Dim MidiShortMessage As Long

    MidiChannel = (Abs(Val(ChannelText.Text)) - 1) Mod 16
    NoteToggle = Not NoteToggle
    If NoteToggle Then
        ' Note On = &H9x, where x = channel
        ' Middle C = &H60
        ' Velocity of 64 = &H40
        MidiShortMessage = &H403C90 + MidiChannel
        SendMessageButton.Caption = "Stop Note"
      Else
        ' Note On = &H9x, where x = channel
        ' Middle C = &H60
        ' Velocity of 0 = Note Off = &H00
        MidiShortMessage = &H3C90 + MidiChannel
        SendMessageButton.Caption = "Send Note"
      End If
    RetValue = midiOutShortMsg(hMidiOut, MidiShortMessage)
    End Sub

