VERSION 2.00
Begin Form Form1 
   Caption         =   "Sprite Animation Project 2"
   ClientHeight    =   4992
   ClientLeft      =   1056
   ClientTop       =   1608
   ClientWidth     =   6420
   Height          =   5412
   Left            =   1008
   LinkTopic       =   "Form1"
   ScaleHeight     =   416
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   535
   Top             =   1236
   Width           =   6516
   Begin PictureBox MaskPicture 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   984
      Index           =   1
      Left            =   3660
      Picture         =   SPRITE2.FRX:0000
      ScaleHeight     =   80
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   80
      TabIndex        =   5
      Top             =   3816
      Width           =   984
   End
   Begin PictureBox MaskPicture 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   984
      Index           =   0
      Left            =   2508
      Picture         =   SPRITE2.FRX:1D3A
      ScaleHeight     =   80
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   80
      TabIndex        =   4
      Top             =   3828
      Width           =   984
   End
   Begin PictureBox SpritePicture 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   984
      Index           =   1
      Left            =   1308
      Picture         =   SPRITE2.FRX:3A74
      ScaleHeight     =   80
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   80
      TabIndex        =   3
      Top             =   3804
      Width           =   984
   End
   Begin PictureBox SpritePicture 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   984
      Index           =   0
      Left            =   156
      Picture         =   SPRITE2.FRX:57AE
      ScaleHeight     =   80
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   80
      TabIndex        =   2
      Top             =   3804
      Width           =   984
   End
   Begin Timer Timer1 
      Interval        =   100
      Left            =   5832
      Top             =   168
   End
   Begin PictureBox BufferPicture 
      AutoRedraw      =   -1  'True
      Height          =   1080
      Left            =   4992
      ScaleHeight     =   88
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   97
      TabIndex        =   1
      Top             =   3792
      Width           =   1188
   End
   Begin PictureBox AnimationPicture 
      AutoSize        =   -1  'True
      Height          =   3540
      Left            =   156
      Picture         =   SPRITE2.FRX:74E8
      ScaleHeight     =   293
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   441
      TabIndex        =   0
      Top             =   132
      Width           =   5316
   End
End
Option Explicit

Declare Function BitBlt Lib "GDI" (ByVal hDestDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal dwRop As Long) As Integer
Declare Function StretchBlt Lib "GDI" (ByVal hDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal nSrcWidth As Integer, ByVal nSrcHeight As Integer, ByVal dwRop As Long) As Integer

Const SRCCOPY = &HCC0020
Const SRCAND = &H8800C6
Const SRCPAINT = &HEE0086


Dim Forward As Integer
Dim Down As Integer
Dim CurrentLeft As Integer
Dim CurrentTop As Integer
Dim OldLeft As Integer
Dim OldTop As Integer
Dim CurrentSpriteCel As Integer

Sub AnimationPicture_Paint ()
    Dim Dummy As Integer
    Dim SrcWidth As Integer
    Dim CurrentX As Integer

    If Forward Then
	SrcWidth = SpritePicture(CurrentSpriteCel).ScaleWidth
	CurrentX = CurrentLeft
      Else
	SrcWidth = -SpritePicture(CurrentSpriteCel).ScaleWidth
	CurrentX = CurrentLeft + SpritePicture(CurrentSpriteCel).ScaleWidth - 1
      End If
    
    Dummy = BitBlt(AnimationPicture.hDC, OldLeft, OldTop, SpritePicture(CurrentSpriteCel).ScaleWidth, SpritePicture(CurrentSpriteCel).ScaleHeight, BufferPicture.hDC, 0, 0, SRCCOPY)
    Dummy = BitBlt(BufferPicture.hDC, 0, 0, SpritePicture(CurrentSpriteCel).ScaleWidth, SpritePicture(CurrentSpriteCel).ScaleHeight, AnimationPicture.hDC, CurrentLeft, CurrentTop, SRCCOPY)
    Dummy = StretchBlt(AnimationPicture.hDC, CurrentX, CurrentTop, SrcWidth, SpritePicture(CurrentSpriteCel).ScaleHeight, MaskPicture(CurrentSpriteCel).hDC, 0, 0, SpritePicture(CurrentSpriteCel).ScaleWidth, SpritePicture(CurrentSpriteCel).ScaleHeight, SRCAND)
    Dummy = StretchBlt(AnimationPicture.hDC, CurrentX, CurrentTop, SrcWidth, SpritePicture(CurrentSpriteCel).ScaleHeight, SpritePicture(CurrentSpriteCel).hDC, 0, 0, SpritePicture(CurrentSpriteCel).ScaleWidth, SpritePicture(CurrentSpriteCel).ScaleHeight, SRCPAINT)
    OldLeft = CurrentLeft
    OldTop = CurrentTop
    ' This next statement is optional.
    BufferPicture.Refresh
    End Sub

Sub Form_Activate ()
    Dim Dummy As Integer
    Dummy = BitBlt(BufferPicture.hDC, 0, 0, SpritePicture(CurrentSpriteCel).ScaleWidth, SpritePicture(CurrentSpriteCel).ScaleHeight, AnimationPicture.hDC, CurrentLeft, CurrentTop, SRCCOPY)

    End Sub

Sub Form_Load ()
    Forward = True
    Down = True
    CurrentLeft = 0
    CurrentTop = 0
    End Sub

Sub Timer1_Timer ()
    Dim Limit As Single

    CurrentSpriteCel = (CurrentSpriteCel + 1) Mod 2
    If (((CurrentLeft + SpritePicture(CurrentSpriteCel).ScaleWidth) >= AnimationPicture.ScaleWidth) And Forward) Then
	Forward = False
      ElseIf ((CurrentLeft <= 0) And Not Forward) Then
	Forward = True
      End If
    If Forward Then
	Limit = AnimationPicture.ScaleWidth - SpritePicture(CurrentSpriteCel).ScaleWidth
	CurrentLeft = MinSingle(CurrentLeft + 20, Limit)
      Else
	Limit = SpritePicture(CurrentSpriteCel).ScaleWidth
	CurrentLeft = MaxSingle(CurrentLeft - 20, 0)
      End If
    If (((CurrentTop + SpritePicture(CurrentSpriteCel).ScaleHeight) >= AnimationPicture.ScaleHeight) And Down) Or ((CurrentTop <= 0) And Not Down) Then
	Down = Not Down
      End If
    If Down Then
	Limit = AnimationPicture.ScaleHeight - SpritePicture(CurrentSpriteCel).ScaleHeight
	CurrentTop = MinSingle(CurrentTop + 7, Limit)
      Else
	CurrentTop = MaxSingle(CurrentTop - 7, 0)
      End If
    
    'AnimationPicture.Refresh
    AnimationPicture_Paint
    End Sub

