VERSION 2.00
Begin Form WaveMixForm 
   Caption         =   "Test WaveMix"
   ClientHeight    =   924
   ClientLeft      =   1944
   ClientTop       =   2892
   ClientWidth     =   4284
   Height          =   1668
   Left            =   1896
   LinkTopic       =   "Form1"
   ScaleHeight     =   924
   ScaleWidth      =   4284
   Top             =   2196
   Width           =   4380
   Begin CommandButton PlayWaveButton 
      Caption         =   "7"
      Height          =   372
      Index           =   6
      Left            =   3540
      TabIndex        =   6
      Top             =   180
      Width           =   432
   End
   Begin CommandButton PlayWaveButton 
      Caption         =   "6"
      Height          =   372
      Index           =   5
      Left            =   3000
      TabIndex        =   5
      Top             =   180
      Width           =   432
   End
   Begin CommandButton PlayWaveButton 
      Caption         =   "5"
      Height          =   372
      Index           =   4
      Left            =   2460
      TabIndex        =   4
      Top             =   180
      Width           =   432
   End
   Begin CommandButton PlayWaveButton 
      Caption         =   "4"
      Height          =   372
      Index           =   3
      Left            =   1920
      TabIndex        =   3
      Top             =   180
      Width           =   432
   End
   Begin CommandButton PlayWaveButton 
      Caption         =   "3"
      Height          =   372
      Index           =   2
      Left            =   1380
      TabIndex        =   2
      Top             =   180
      Width           =   432
   End
   Begin CommandButton PlayWaveButton 
      Caption         =   "2"
      Height          =   372
      Index           =   1
      Left            =   840
      TabIndex        =   1
      Top             =   180
      Width           =   432
   End
   Begin CommandButton PlayWaveButton 
      Caption         =   "1"
      Height          =   372
      Index           =   0
      Left            =   300
      TabIndex        =   0
      Top             =   180
      Width           =   432
   End
   Begin Menu FileMenu 
      Caption         =   "File"
      Begin Menu QuitOption 
         Caption         =   "Quit"
      End
   End
End
Option Explicit

Dim WaveMixConfiguration As MIXCONFIG
Dim hThisMixSession As Integer
Dim WaveFiles(7) As String
Dim lpMixWaves(7) As Long

Sub Form_Activate ()
    Dim RetValue As Integer

    RetValue = WaveMixActivate(hThisMixSession, True)
    End Sub

Sub Form_Deactivate ()
    Dim RetValue As Integer

    RetValue = WaveMixActivate(hThisMixSession, False)
    End Sub

Sub Form_Load ()
    Dim Counter As Integer
    Dim RetValue As Integer

    WaveMixConfiguration.wSize = Len(WaveMixConfiguration)
    WaveMixConfiguration.dwFlags = WMIX_CONFIG_CHANNELS Or WMIX_CONFIG_SAMPLINGRATE
    WaveMixConfiguration.wChannels = 2
    WaveMixConfiguration.wSamplingRate = 11
    hThisMixSession = WaveMixConfigureInit(WaveMixConfiguration)
    WaveFiles(1) = Left$(App.Path, 2) & "\wavemix\1.wav"
    WaveFiles(2) = Left$(App.Path, 2) & "\wavemix\2.wav"
    WaveFiles(3) = Left$(App.Path, 2) & "\wavemix\3.wav"
    WaveFiles(4) = Left$(App.Path, 2) & "\wavemix\4.wav"
    WaveFiles(5) = Left$(App.Path, 2) & "\wavemix\5.wav"
    WaveFiles(6) = Left$(App.Path, 2) & "\wavemix\6.wav"
    WaveFiles(7) = Left$(App.Path, 2) & "\wavemix\7.wav"
    For Counter = 1 To 7
        lpMixWaves(Counter) = WaveMixOpenWave(hThisMixSession, WaveFiles(Counter), 0, WMIX_FILE)
        Next Counter
    RetValue = WaveMixOpenChannel(hThisMixSession, 0, WMIX_ALL)
    If RetValue Then
        MsgBox "Unable to open channels.", 16, "WaveMix Error"
        Unload WaveMixForm
        End
      End If
    RetValue = WaveMixActivate(hThisMixSession, True)
    End Sub

Sub Form_Unload (Cancel As Integer)
    Dim Counter As Integer
    Dim RetValue As Integer

    RetValue = WaveMixCloseChannel(hThisMixSession, 0, WMIX_ALL)
    For Counter = 1 To 7
        lpMixWaves(Counter) = WaveMixFreeWave(hThisMixSession, lpMixWaves(Counter))
        Next Counter
    RetValue = WaveMixCloseSession(hThisMixSession)
    End Sub

Sub PlayWaveButton_Click (Index As Integer)
    Dim RetValue As Integer
    Dim MixPlayParameters As MIXPLAYPARAMS

    MixPlayParameters.wSize = Len(MixPlayParameters)
    MixPlayParameters.hMixSession = hThisMixSession
    MixPlayParameters.iChannel = Index
    MixPlayParameters.lpMixWave = lpMixWaves(Index + 1)
    MixPlayParameters.hWndNotify = 0
    MixPlayParameters.dwFlags = WMIX_HIGHPRIORITY 'Or WMIX_CLEARQUEUE
    MixPlayParameters.wLoops = 0
    'RetValue = WaveMixFlushChannel(hThisMixSession, Index, WMIX_NOREMIX)
    RetValue = WaveMixPlay(MixPlayParameters)
    End Sub

Sub QuitOption_Click ()
    Unload WaveMixForm
    End
    End Sub

