Option Explicit

Declare Function mciSendString Lib "MMSystem" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal wReturnLength As Integer, ByVal hCallback As Integer) As Long

Type DiskTitleRecords
    IDNumber As Long
    Title As String * 128
    End Type


Global mciResult As Integer
Global ReturnString As String * 128
Global CDTitleFile As Integer
Global CurrentTitleRecordNumber As Integer

Function CleanString (MessyString As String) As String
    CleanString = Left$(MessyString, InStr(MessyString, Chr$(0)) - 1)
    End Function

Function GetDiskTitleRecord (AnyDiskTitleRecord As DiskTitleRecords)
    Dim NumberOfTracks As Integer
    Dim DiskLength As Long
    Dim DiskID As Long
    Dim RecordPosition As Integer
    Dim Found As Integer

    mciResult = mciSendString("status CDAudio number of tracks", ReturnString, 127, 0)
    NumberOfTracks = Val(CleanString(ReturnString))
    mciResult = mciSendString("set CDAudio time format milliseconds", ReturnString, 127, 0)
    mciResult = mciSendString("status CDAudio length", ReturnString, 127, 0)
    DiskLength = Val(CleanString(ReturnString))
    DiskID = NumberOfTracks * DiskLength
    mciResult = mciSendString("set CDAudio time format tmsf", ReturnString, 127, 0)

    RecordPosition = 0
    Do
        RecordPosition = RecordPosition + 1
        Get CDTitleFile, RecordPosition, AnyDiskTitleRecord
        Found = (DiskID = AnyDiskTitleRecord.IDNumber)
        Loop Until Found Or EOF(CDTitleFile)
    If Found Then
        GetDiskTitleRecord = RecordPosition
      Else
        GetDiskTitleRecord = 0
        AnyDiskTitleRecord.IDNumber = DiskID
      End If
    End Function

Sub OpenTitleFile ()
    Dim AnyTitleRecord As DiskTitleRecords

    CDTitleFile = 1
    Open App.Path & "\CDTitles.Dat" For Random As CDTitleFile Len = Len(AnyTitleRecord)
    End Sub

Sub SaveDiskTitleRecord (AnyDiskTitleRecord As DiskTitleRecords, RecordPosition As Integer)
    Dim FileSize As Integer

    If RecordPosition <> 0 Then
        Put CDTitleFile, RecordPosition, AnyDiskTitleRecord
      Else
        FileSize = LOF(CDTitleFile) \ Len(AnyDiskTitleRecord)
        RecordPosition = FileSize + 1
        Put CDTitleFile, RecordPosition, AnyDiskTitleRecord
      End If
    End Sub

