VERSION 2.00
Begin Form MCIPlay 
   Caption         =   "MCI Player"
   ClientHeight    =   5160
   ClientLeft      =   1092
   ClientTop       =   1824
   ClientWidth     =   7080
   Height          =   5580
   Left            =   1044
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   5160
   ScaleWidth      =   7080
   Top             =   1452
   Width           =   7176
   Begin TextBox ReturnStringText 
      Height          =   552
      Left            =   1020
      TabIndex        =   8
      Top             =   2040
      Width           =   5892
   End
   Begin TextBox ErrorText 
      Height          =   612
      Left            =   1020
      TabIndex        =   7
      Top             =   1140
      Width           =   5892
   End
   Begin TextBox CommandStringText 
      Height          =   612
      Left            =   1260
      TabIndex        =   6
      Top             =   240
      Width           =   5652
   End
   Begin CommandButton WaveOutButton 
      Caption         =   "waveOutWrite"
      Height          =   480
      Left            =   4080
      TabIndex        =   5
      Top             =   4500
      Width           =   2112
   End
   Begin CommandButton SendCommandButton 
      Caption         =   "mciSendCommand"
      Height          =   492
      Left            =   4080
      TabIndex        =   4
      Top             =   3720
      Width           =   2112
   End
   Begin CommandButton SendStringButton 
      Caption         =   "mciSendString"
      Height          =   480
      Left            =   4080
      TabIndex        =   3
      Top             =   3000
      Width           =   2124
   End
   Begin CommandButton ExecuteButton 
      Caption         =   "mciExecute"
      Height          =   504
      Left            =   960
      TabIndex        =   2
      Top             =   4500
      Width           =   2172
   End
   Begin CommandButton PlaySoundButton 
      Caption         =   "sndPlaySound"
      Height          =   492
      Left            =   960
      TabIndex        =   1
      Top             =   3720
      Width           =   2172
   End
   Begin CommandButton MessageBeepButton 
      Caption         =   "MessageBeep"
      Height          =   495
      Left            =   960
      TabIndex        =   0
      Top             =   3000
      Width           =   2175
   End
   Begin Label Label3 
      Caption         =   "Return String:"
      Height          =   612
      Left            =   360
      TabIndex        =   11
      Top             =   2040
      Width           =   612
   End
   Begin Label Label2 
      Caption         =   "Error:"
      Height          =   492
      Left            =   480
      TabIndex        =   10
      Top             =   1140
      Width           =   492
   End
   Begin Label Label1 
      Caption         =   "Command String:"
      Height          =   552
      Left            =   360
      TabIndex        =   9
      Top             =   240
      Width           =   852
   End
End
Option Explicit

Declare Function mciExecute Lib "MMSystem" (ByVal CommandString As String) As Integer
Declare Sub MessageBeep Lib "User" (ByVal wAlert As Integer)
Declare Function sndPlaySound Lib "MMSystem" (ByVal lpSound As String, ByVal flag As Integer) As Integer
Declare Function mciSendString Lib "MMSystem" (ByVal lpstrCommand As String, ByVal lpstrRtnString As Any, ByVal wRtnLength As Integer, ByVal hCallback As Integer) As Long
Declare Function mciSendCommand Lib "MMSystem" (ByVal wDeviceID As Integer, ByVal wMessage As Integer, ByVal dwParam1 As Long, dwParam2 As Any) As Long
Declare Function lstrcpy Lib "Kernel" (lp1 As Any, lp2 As Any) As Long
Declare Function mciGetErrorString Lib "MMSystem" (ByVal dwError As Long, ByVal lpstrBuffer As String, ByVal wLength As Integer) As Integer

Sub ExecuteButton_Click ()
    Dim Successful As Integer
    Dim CommandString As String

    CommandString = CommandStringText.Text
    Successful = mciExecute(CommandString)
    If Successful Then
        ErrorText.Text = "Successful " + Str$(Successful)
      Else
        ErrorText.Text = "Unsuccessful " + Str$(Successful)
      End If
    End Sub

Sub MessageBeepButton_Click ()
    MessageBeep MB_ICONEXCLAMATION
    End Sub

Sub PlaySoundButton_Click ()
    Dim Successful As Integer
    Dim SoundName As String

    SoundName = CommandStringText.Text
    Successful = sndPlaySound(SoundName, SND_ASYNC)
    If Successful Then
        ErrorText.Text = "Successful, Function Returned " + Str$(Successful)
      Else
        ErrorText.Text = "Unsuccessful, Function Returned " + Str$(Successful)
      End If
    End Sub

Sub SendCommandButton_Click ()
    Dim Dummy As Long
    Dim mciError As Long
    Dim DeviceType As PseudoString
    Dim ElementName As PseudoString
    Dim mciOpenParms As MCI_WAVE_OPEN_PARMS
    Dim mciPlayParms As MCI_PLAY_PARMS
    Dim mciFlags As Long
    Dim wDeviceID As Integer
    Dim mciErrorString As String * 256

    ErrorText.Text = ""
    mciOpenParms.dwCallback = 0&
    mciOpenParms.wDeviceID = 0
    mciOpenParms.wReserved0 = 0
    DeviceType.AnyString = "waveaudio" + Chr$(0)
    ElementName.AnyString = "c:\windows\tada.wav" + Chr$(0)
    mciOpenParms.lpstrDeviceType = lstrcpy(DeviceType, DeviceType)
    mciOpenParms.lpstrElementName = lstrcpy(ElementName, ElementName)
    mciOpenParms.lpstrAlias = 0&
    mciOpenParms.dwBufferSeconds = 0&
    mciFlags = MCI_OPEN_TYPE Or MCI_OPEN_ELEMENT
    
    mciError = mciSendCommand(0, MCI_OPEN, mciFlags, mciOpenParms)
    If Not mciError Then
        wDeviceID = mciOpenParms.wDeviceID
        mciError = mciSendCommand(wDeviceID, MCI_PLAY, MCI_WAIT, mciPlayParms)
        If Not mciError Then
            mciError = mciSendCommand(wDeviceID, MCI_CLOSE, 0, ByVal 0&)
          End If
      End If
    Dummy = mciGetErrorString(mciError, mciErrorString, 255)
    ErrorText.Text = mciErrorString

    End Sub

Sub SendStringButton_Click ()
    Dim mciError As Long
    Dim ReturnString As String * 512
    Dim Dummy As Integer
    Dim mciErrorString As String * 256
    Dim CommandString As String

    ErrorText.Text = ""
    CommandString = CommandStringText.Text
    mciError = mciSendString(CommandString, ByVal ReturnString, Len(ReturnString) - 1, 0)
    Dummy = mciGetErrorString(mciError, mciErrorString, 255)
    ErrorText.Text = mciErrorString
    ReturnStringText.Text = ReturnString
    End Sub

Sub WaveOutButton_Click ()
    Dim Dummy As Integer
    Dim WaveFileOpened As Integer

    If OpenWaveFile("C:\Windows\Tada.WAV") Then
        Dummy = WaveOut()
      End If

    End Sub

