VERSION 2.00
Begin Form VidCap1F1 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "VB Video Capture"
   ClientHeight    =   3960
   ClientLeft      =   2460
   ClientTop       =   4500
   ClientWidth     =   5892
   Height          =   4704
   Left            =   2412
   LinkTopic       =   "Form1"
   ScaleHeight     =   3960
   ScaleWidth      =   5892
   Top             =   3804
   Width           =   5988
   Begin SSPanel Panel3D2 
      Align           =   1  'Align Top
      Alignment       =   8  'Center - BOTTOM
      BackColor       =   &H00C0C0C0&
      Font3D          =   0  'None
      Height          =   3432
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Width           =   5892
      Begin CommonDialog CaptureFileDialog 
         DefaultExt      =   ".AVI"
         Filter          =   "Video (*.avi)|*.avi"
         Left            =   5340
         Top             =   2940
      End
      Begin CAPWND CapWnd1 
         AudioBits       =   8
         AudioChannels   =   1
         AudioRate       =   11025
         AutoSize        =   -1  'True
         CaptureAudio    =   -1  'True
         CaptureDOSMem   =   0   'False
         CaptureFile     =   "C:\CAPTURE.AVI"
         CaptureHitOK    =   0   'False
         CaptureLimit    =   0
         CaptureUseLimit =   0   'False
         Connect         =   0   'False
         DriverNum       =   0
         Height          =   1872
         Left            =   60
         MCIDeviceEnable =   0   'False
         MCIDeviceName   =   ""
         MCIStartMS      =   0
         MCIStepCapture  =   0   'False
         MCIStopMS       =   0
         Overlay         =   0   'False
         PalNumColors    =   256
         PalNumFrames    =   20
         Preview         =   0   'False
         PreviewRate     =   1
         Top             =   120
         VideoRate       =   15
         Width           =   1992
         Yield           =   0   'False
      End
   End
   Begin SSPanel Panel3D1 
      Align           =   2  'Align Bottom
      Alignment       =   8  'Center - BOTTOM
      BackColor       =   &H00C0C0C0&
      Font3D          =   0  'None
      Height          =   492
      Left            =   0
      TabIndex        =   0
      Top             =   3468
      Width           =   5892
      Begin SSPanel StatusPanel 
         Alignment       =   8  'Center - BOTTOM
         BackColor       =   &H00C0C0C0&
         BevelOuter      =   1  'Inset
         Caption         =   "Status Panel"
         Font3D          =   0  'None
         Height          =   252
         Left            =   3360
         TabIndex        =   4
         Top             =   120
         Width           =   2412
      End
      Begin CommandButton EndCaptureButton 
         Caption         =   "End Capture"
         Enabled         =   0   'False
         Height          =   372
         Left            =   1800
         TabIndex        =   2
         Top             =   60
         Width           =   1392
      End
      Begin CommandButton StartButton 
         Caption         =   "Start Capture"
         Height          =   372
         Left            =   180
         TabIndex        =   1
         Top             =   60
         Width           =   1392
      End
   End
   Begin Menu FileMenu 
      Caption         =   "&File"
      Begin Menu LoadPaletteOption 
         Caption         =   "&Load Palette"
      End
      Begin Menu SetCapFileOption 
         Caption         =   "&Set Capture File"
      End
      Begin Menu Break1 
         Caption         =   "-"
      End
      Begin Menu SaveAsOption 
         Caption         =   "Save &Captured Video As..."
      End
      Begin Menu SavePaletteOption 
         Caption         =   "Save &Palette"
      End
      Begin Menu SaveFrameOption 
         Caption         =   "Save Single &Frame"
         Enabled         =   0   'False
      End
      Begin Menu Break2 
         Caption         =   "-"
      End
      Begin Menu ExitOption 
         Caption         =   "E&xit"
      End
   End
   Begin Menu EditMenu 
      Caption         =   "&Edit"
      Begin Menu CopyOption 
         Caption         =   "&Copy Frame"
         Shortcut        =   ^C
      End
      Begin Menu PastePalOption 
         Caption         =   "Paste &Palette"
         Enabled         =   0   'False
      End
      Begin Menu Break3 
         Caption         =   "-"
      End
      Begin Menu PreferencesOption 
         Caption         =   "Pre&ferences"
         Enabled         =   0   'False
      End
   End
   Begin Menu OptionsMenu 
      Caption         =   "&Options"
      Begin Menu AudioCaptureOption 
         Caption         =   "Capture &Audio"
      End
      Begin Menu Break4 
         Caption         =   "-"
      End
      Begin Menu VideoFormatOption 
         Caption         =   "&Video Format"
      End
      Begin Menu VideoSourceOption 
         Caption         =   "Video &Source"
      End
      Begin Menu VideoDisplayOption 
         Caption         =   "Video &Display"
      End
      Begin Menu Break5 
         Caption         =   "-"
      End
      Begin Menu PreviewOption 
         Caption         =   "&Preview Video"
      End
      Begin Menu OverlayOption 
         Caption         =   "&Overlay Video"
      End
   End
   Begin Menu CaptureMenu 
      Caption         =   "&Capture"
      Begin Menu SingleFrameOption 
         Caption         =   "&Single Frame"
      End
      Begin Menu FramesOption 
         Caption         =   "&Frames..."
         Enabled         =   0   'False
      End
      Begin Menu CaptureVideoOption 
         Caption         =   "&Video..."
      End
      Begin Menu PaletteOption 
         Caption         =   "&Palette..."
         Enabled         =   0   'False
      End
   End
End
Option Explicit

Sub AudioCaptureOption_Click ()
    If Not AudioCaptureOption.Checked Then
        CapWnd1.AudioBits = 8
        CapWnd1.AudioChannels = 1
        CapWnd1.AudioRate = 22050
        CapWnd1.CaptureAudio = True
        AudioCaptureOption.Checked = True
      Else
        CapWnd1.CaptureAudio = False
        AudioCaptureOption.Checked = False
      End If
    End Sub

Sub CaptureVideoOption_Click ()
    CapWnd1.DriverNum = 0
    CapWnd1.Connect = True
    CapWnd1.CaptureLimit = 20 '20 seconds
    CapWnd1.CaptureUseLimit = True
    CapWnd1.VideoRate = 15
    CapWnd1.Capture = True
    End Sub

Sub CapWnd1_Error ()
    If CapWnd1.ErrorNum > 0 Then
        MsgBox CapWnd1.Error, , "Video Capture Error"
      End If
    End Sub

Sub CapWnd1_Status ()
    StatusPanel.Caption = CapWnd1.Status
    End Sub

Sub CopyOption_Click ()
    CapWnd1.EditCopy = True
    End Sub

Sub EndCaptureButton_Click ()
    CapWnd1.CaptureStop = True
    End Sub

Sub ExitOption_Click ()
    Unload VidCap1F1
    End
    End Sub

Sub Form_Load ()
    CapWnd1.Top = Panel3D2.Height \ 2 - CapWnd1.Height \ 2
    CapWnd1.Left = Panel3D2.Width \ 2 - CapWnd1.Width \ 2
    CapWnd1.DriverNum = 0
    CapWnd1.Connect = True
    OverlayOption.Enabled = CapWnd1.CanOverlay
    End Sub

Sub LoadPaletteOption_Click ()
    CaptureFileDialog.DefaultExt = ".PAL"
    CaptureFileDialog.Filter = "Palette (*.pal)|*.pal"
    CaptureFileDialog.Action = 1
    CapWnd1.PalOpen = CaptureFileDialog.Filename
    End Sub

Sub OverlayOption_Click ()
    If CapWnd1.CanOverlay Then
        If OverlayOption.Checked Then
            CapWnd1.Overlay = False
            OverlayOption.Checked = False
          Else
            CapWnd1.Overlay = True
            OverlayOption.Checked = True
          End If
      End If
    End Sub

Sub PreviewOption_Click ()
    If Not PreviewOption.Checked Then
        CapWnd1.PreviewRate = CapWnd1.VideoRate
        CapWnd1.Preview = True
        PreviewOption.Checked = True
      Else
        CapWnd1.Preview = False
        PreviewOption.Checked = False
      End If
    End Sub

Sub SaveAsOption_Click ()
    CaptureFileDialog.DefaultExt = ".avi"
    CaptureFileDialog.Filter = "Video (*.avi)|*.avi"
    CaptureFileDialog.Action = 1
    CapWnd1.CaptureSave = CaptureFileDialog.Filename
    End Sub

Sub SavePaletteOption_Click ()
    CaptureFileDialog.DefaultExt = ".pal"
    CaptureFileDialog.Filter = "Palette (*.pal)|*.pal"
    CaptureFileDialog.Action = 1
    CapWnd1.PalSave = CaptureFileDialog.Filename
    End Sub

Sub SetCapFileOption_Click ()
    CaptureFileDialog.DefaultExt = ".AVI"
    CaptureFileDialog.Filter = "Video (*.avi)|*.avi"
    CaptureFileDialog.Action = 1
    CapWnd1.CaptureFile = CaptureFileDialog.Filename
    End Sub

Sub SingleFrameOption_Click ()
    CapWnd1.SingleFrameOpen = True
    CapWnd1.SingleFrame = True
    CapWnd1.SingleFrameClose = True
    End Sub

Sub StartButton_Click ()
    CapWnd1.DriverNum = 0
    CapWnd1.Connect = True
    CapWnd1.CaptureLimit = 20 '20 seconds
    CapWnd1.CaptureUseLimit = True
    CapWnd1.VideoRate = 15
    CapWnd1.Capture = True
    End Sub

Sub VideoDisplayOption_Click ()
    CapWnd1.VideoDisplayDlg = True
    End Sub

Sub VideoFormatOption_Click ()
    CapWnd1.VideoFormatDlg = True
    CapWnd1.Top = Panel3D2.Height \ 2 - CapWnd1.Height \ 2
    CapWnd1.Left = Panel3D2.Width \ 2 - CapWnd1.Width \ 2
    End Sub

Sub VideoSourceOption_Click ()
    CapWnd1.VideoSourceDlg = True
    End Sub

